#pragma once
#include "GrayscaleImage.h"
#include "MSERWrapper.h"

/**
 * @class	CAffineNormalizer
 *
 * @brief	An affine normalizer.
 *
 * @author	Tato
 * @date	23/02/2014
 */

class CAffineNormalizer
{
private:
	CGrayscaleImage *ComputeRotationMatrix(CGrayscaleImage &mask, double &muX, double &muY);

public:
	CAffineNormalizer(void);

	/**
	 * @fn	void CAffineNormalizer::Normalize(CMSER &mser, CGrayscaleImage &input, CGrayscaleImage &inputForNormalization, CGrayscaleImage &output);
	 *
	 * @brief	Normalizes.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @param [in,out]	mser				 	The mser.
	 * @param [in,out]	input				 	The input.
	 * @param [in,out]	inputForNormalization	The input for normalization.
	 * @param [in,out]	output				 	The output.
	 * @param [in,out]	rotMatrix				The rotation matrix used to resample the MSER into the patch.
	 * @param [in,out]	translation				The translation used to resample the MSER into the patch.
	 */

	void Normalize(CMSER &mser, CGrayscaleImage &input, CGrayscaleImage &inputForNormalization, CGrayscaleImage &output, CGrayscaleImage **rotMatrix, std::pair<double, double> &translation);
	~CAffineNormalizer(void);
};

