#pragma once
#include "MSERWrapper.h"
#include "GrayscaleImage.h"

class CDescriptor
{
protected:
	CMSER *_mser;
	CGrayscaleImage *_img;
	CGrayscaleImage *_affineInvariantImage;
	CGrayscaleImage *_rotMatrix;
	std::pair<double, double> _translation;
	virtual CGrayscaleImage *GetInput() { return NULL; }
	virtual CGrayscaleImage *GetNormalizationInput() { return NULL;  }

public:
	void CalculateSIFTDescriptor(vector<double*> &descs);
	void Init(CMSER &mser, CGrayscaleImage &img);
	CGrayscaleImage *GetRotationMatrix() { return _rotMatrix; }
	std::pair<double, double> GetTranslation() { return _translation; }
	CDescriptor();
	CGrayscaleImage *GetAffineInvariantImage() { return _affineInvariantImage; }
	virtual ~CDescriptor(void);
};

