#pragma once
#include "Kernel.h"
#include "IO_PNG/io_png.h"

class CGrayscaleImage
{
private:
	size_t _width;
	size_t _height;
	double *_img;
public:
	CGrayscaleImage(const char *filename);
	CGrayscaleImage(unsigned char* img, size_t width, size_t height);
	CGrayscaleImage(double *img, size_t width, size_t height);
	CGrayscaleImage(size_t width, size_t height);
	CGrayscaleImage(CGrayscaleImage *image);
	~CGrayscaleImage(void);
	inline double GetValue(int pos) { return _img[pos]; }
	double GetPixel(int x, int y);
	double GetBilinearInterpolatedPixel(double x, double y);
	void SetPixel(int x, int y, double value);
	unsigned char* GetGrayscaleVersion();
	float* GetFloatVersion();
	inline double *GetDoubleImage() { return _img; }
	void Convolution(CKernel &kernel, CGrayscaleImage *res);
	inline int Width() { return (int) _width; }
	inline int Height() { return (int) _height; }
};

