#pragma once
#include <math.h>
#include <utility>
#ifndef M_PI
#define M_PI (3.14159265358979323846)
#endif
#define FILE_NOT_FOUND_EXCEPTION 1
#ifndef MAX
#define MAX(x,y) (x) > (y) ? (x) : (y)
#endif
#ifndef MIN
#define MIN(x,y) (x) < (y) ? (x) : (y)
#endif
#define ROUND(x) floor(x + 0.5)
typedef std::pair<std::size_t, std::size_t> CPixel;
typedef std::pair<double, double> CDPixel;


/**
 * @fn	double distanceBetweenPixels(const CPixel &p1, const CPixel &p2)
 *
 * @brief	Distance between pixels.
 *
 * @author	Tato
 * @date	21/02/2014
 *
 * @param	p1	The first CPixel.
 * @param	p2	The second CPixel.
 *
 * @return	A double.
 */

double distanceBetweenPixels(const CDPixel &p1, const CDPixel &p2);
