/**
 * @file	C:\Users\Tato\Documents\GitHub\IPOL_MSER\MSERSIFT\src\ImageResampler.cpp
 *
 * @brief	Implements the image resampler class.
 */

#include "ImageResampler.h"

/**
 * @fn	CImageResampler::CImageResampler(CGrayscaleImage *img)
 *
 * @brief	Constructor.
 *
 * @author	Tato
 * @date	18/02/2014
 *
 * @param [in]	img		The input image to resample.
 */

CImageResampler::CImageResampler(CGrayscaleImage *img)
{
	_img = img;
}

/**
 * @fn	CImageResampler::~CImageResampler(void)
 *
 * @brief	Destructor.
 *
 * @author	Tato
 * @date	18/02/2014
 */

CImageResampler::~CImageResampler(void)
{
}

/**
 * @fn	CGrayscaleImage *CImageResampler::SubsampleImageInHalf()
 *
 * @brief	Subsample input image in half.
 *
 * @author	Tato
 * @date	18/02/2014
 *
 * @return	Input image subsampled taking one out of two pixels.
 */

CGrayscaleImage *CImageResampler::SubsampleImageInHalf()
{
	CGrayscaleImage *res = new CGrayscaleImage(_img->Width() / 2, _img->Height() / 2);
	for (int x=0;x<res->Width();x++)
		for(int y=0;y<res->Height();y++)
		{
			res->SetPixel(x,y, _img->GetPixel(x*2,y*2));
		}
	return res;
}
