#pragma once

/**
 * @class	CKernel
 *
 * @brief	A kernel.
 *
 * @author	Tato
 * @date	23/02/2014
 */

class CKernel
{
private:
	int _width, _height;
	double **_data;
public:
	CKernel(int width, int height);
	void InitializeGaussian2DKernel(double sigma);
	void InitializeGaussian1DKernel(double sigma);
	double GetValue(int x, int y);
	inline int GetWidth() { return _width; }
	inline int GetHeight() { return _height; }
	~CKernel(void);
};

