/*
 *  matching.h
 *  MSER
 *
 *  Created by Edouard Oyallon on 10/26/11.
 *  Copyright 2011 __MyCompanyName__. All rights reserved.
 *
 */
#define RATE 0.01


typedef pair<MSER*,MSER*> p;
typedef  vector<p> listMatch;

/**
 * Draw lines between (xa,ya) and (xb,yb) with intensity intensite.
 */	
void lign(float *img,int w,int xa,int ya,int xb,int yb,float intensite)
{
//	xa=(int) xa;ya=(int)ya;xb=(int)xb;yb=(int)yb;
	if(xa>xb)
	{
		
		lign(img,w,xb,yb,xa,ya,intensite);
	}
	
	else
	{
		if(xb==xa)
		{
			if(ya<yb)
				for(int i=0;i<=yb-ya;i++)
					img[xa+w*(ya+i)]=intensite;
			else 
				for(int i=0;i<=ya-yb;i++)
					img[xa+w*(yb+i)]=intensite;
			
			
		}
		else
		{
			float a,b;
			a=(float)(yb-ya)/(xb-xa);
			b=ya;
			for(int i=0;i<=xb-xa+1;i++)
			{
				if(a>0)
				{
					for(int j=(int)((float)(a*i)+b);j<(int)((float)(a*(i+1))+b);j++)
						if ( (j>ya && j<yb) || (j>yb && j<ya))
							
							img[xa+i+w*j]=intensite;
				}
				
				else 
					for(int j=(int)((float)(a*(i+1))+b);j<(int)((float)(a*i)+b);j++)
						if ( (j>ya && j<yb) || (j>yb && j<ya))
							img[xa+i+w*j]=intensite;
				
				
				
				
				
			}
		}
		
	}
}







/**
 * Make a vote for the best matcher.
 * @param element The element you want to match.
 * @param k The position in the vector of the moment of the element you want to match.
 * @param x The list of MSER in which we're going to seek a match
 * @param threshold The number of elements to take
 * @param array The array of the threshold-selected elements.
 */	
int* getVotediDescriptor(float element,int k,listMSER* x,int threshold,int* array)
{
	array[0]=0;
		// We order the elements <threshold.
	for(int i=1;i<threshold;i++)
	 {
		array[i]=i;

		
		int j=i;
			//cout<<"bl"<<endl;
			//cout<<((*x)[array[0]]->vect)[k]-element<<endl;
			//cout<<"0,k"<<k<<" et "<<((*x)[array[0]]->vect)[k]<<endl;
			//		cout<<((*x)[array[1]]->vect)[k]-element<<endl;

		while(j>0 && ABS(((*x)[array[j]]->vect)[k]-element)<ABS(element-((*x)[array[j-1]]->vect)[k]))
		 {

			int tmp=array[j];
			array[j]=array[j-1];
			array[j-1]=tmp;
			/*if(j==1)
			 {cout<<((*x)[array[j]]->vect)[k]-element<<endl;
				 cout<<((*x)[array[j-1]]->vect)[k]-element<<endl;
			 }*/
				
			j--;
		 }
	 }

	for(int i=threshold;i<x->size();i++)
	 {
		int j=threshold-1;
		if(ABS(element-((*x)[i]->vect)[k])<ABS(element-((*x)[array[j]]->vect)[k]))
			array[j]=i;
		while(j>0 && ABS(element-((*x)[array[j]]->vect)[k])<ABS(element-((*x)[array[j-1]]->vect)[k]))
		 {
			int tmp=array[j];
			array[j]=array[j-1];
			array[j-1]=tmp;
			j--;
		 }
	 }
		//cout<<array[0]<<" and "<<array[1]<<endl;
	return array;
}
	/// Basic procedure to sort an array
void sortArray(int* array,int size)
{
	
	for(int i=1;i<size;i++)
	 {

		int j=i;
		while(j>0 && array[j]<array[j-1])
		 {
			int tmp=array[j];
			array[j]=array[j-1];
			array[j-1]=tmp;
			j--;
		 }
	 }
}




	/// Compute d(x,y) using the previous methods
int* d(listMSER* x,listMSER* y,int threshold)
{
	int* match=new int[x->size()];
	for(int i=0;i<x->size();i++)
	 {
		int* vote=new int[MAX_K*MAX_L*threshold];
		int* vote_tmp=vote;
		for(int j=0;j<MAX_K*MAX_L;j++)
		 {
			getVotediDescriptor(((*x)[i]->vect)[j],j,y,threshold,vote_tmp);

			vote_tmp+=threshold;
		 }
		sortArray(vote,MAX_K*MAX_L*threshold);
		int count=1;
		int bestCount=1;
		int bestVote=vote[0];
		
		for(int j=1;j<MAX_K*MAX_L*threshold;j++)
		 {
				//jcout<<vote[j]<<endl;
			if(vote[j]==vote[j-1])
				count++;
			else 
				count=1;
			if(count>bestCount)
			 {
				bestVote=vote[j];
				bestCount=count;
			 }
		 }
		match[i]=bestVote;
	 }
	return match;
	
}

	/// Match
listMatch* matchDescriptor(listMSER * l1, listMSER * l2)
{

	listMatch* match=new listMatch();
	if((int)(l1->size()*RATE)*(int)(l2->size()*RATE)>0)
	 {

		int* a=d(l1,l2,l1->size()*RATE);
		int* b=d(l2,l1,l2->size()*RATE);
		for(int i=0;i<l2->size();i++)
		 {
				//cout<<a[i]<<" et "<<b[a[i]]<<endl;
			if(a[b[i]]==i)
			
			 {
			
				pair<MSER*,MSER*> p;
				p.first=(*l1)[b[i]];
				p.second=(*l2)[i];
				match->push_back(p);	
			 }
			else {
					cout<<i<<"and a "<<a[i]<<" and b "<<b[i]<<endl;
			}

	 }
	
	/*float thrm=RATE*RATE;
	
	for(int i=0;i<l1->size();i++)
	{
		int position=-1;
		float d1=3;
		float d2=3;
		
		for(int j=0;j<l2->size();j++)
		{
			float d=euclideanDistance((*l1)[i]->vect,(*l2)[j]->vect);
			//We seek the secund minimum
			
			
			d2=((d2>d)?d:d2);
			if( d1>d)
			{
				position=j;
				d2=d1;
				d1=d;
			}
			
			
			//cout<<d<<endl;
			
		}
		
		// We want its position positive(found a min) and that there are at least another min behind it at 0.65 ratio
		if(position>=0  && thrm*d2>d1)

			{
			
			pair<MSER*,MSER*> p;
			p.first=(*l1)[i];
			p.second=(*l2)[position];
			
			match->push_back(p);	
		}
		
		
	}
	
	return match;
	*/
	 }
	return match;
}