#ifdef _OPENMP
#include <omp.h>
#endif
#include <iostream>
#include "MserPlusSiftMain.h"
#include <cstdlib>
#include <vld.h> 

using namespace std;


void ExtractMSERsExample(char *filename, int MSERdelta)
{
	const CMSERList *mserList;
	vector<vector<double*>* > *mserDescriptors;
	vector<CGrayscaleImage * > *mserRotations;
	vector<std::pair<double, double>> *mserTranslations;
	double scale;
	CMserPlusSiftMain mserPlusSift;
	int qtyMSER = mserPlusSift.GetMSERSiftFeatures(CMserPlusSiftMain::MSERTexture, filename, MSERdelta, &mserList, &mserDescriptors, &mserRotations, &mserTranslations, &scale);

	// TODO: Do something with all the MSER information


	// Finally, free memory
	for (int i = 0; i < (int)mserList->size(); i++)
	{
		// MSERs
		delete mserList->at(i);
		// Descriptors
		for (int j = 0; j < (int)mserDescriptors->at(i)->size(); j++)
		{
			delete[] mserDescriptors->at(i)->at(j);
		}
		delete mserDescriptors->at(i);
		// Transformation
		delete mserRotations->at(i);
	}
	delete mserTranslations;
	delete mserRotations;
	delete mserDescriptors;
	delete mserList;
	CParams::KillInstance();
}
