#pragma once
#include "IO_PNG/io_png.h"
#include "GrayscaleImage.h"
#include <vector>
#include "MSERWrapper.h"

using namespace std;

/**
 * @class	CMatchesImageGenerator
 *
 * @brief	The matches image generator.
 *
 * @author	Tato
 * @date	23/02/2014
 */

class CMatchesImageGenerator
{
private:
	CGrayscaleImage &_im1;
	CGrayscaleImage &_im2;
	void lign(float *img,int w,int xa,int ya,int xb,int yb);//,float intensite);
public:

	/**
	 * @fn	CMatchesImageGenerator::CMatchesImageGenerator(CGrayscaleImage &im1, CGrayscaleImage &im2);
	 *
	 * @brief	Constructor.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @param [in,out]	im1	The first im.
	 * @param [in,out]	im2	The second im.
	 */

	CMatchesImageGenerator(CGrayscaleImage &im1, CGrayscaleImage &im2);

	/**
	 * @fn	void CMatchesImageGenerator::GenerateImage(const char *filename, vector<pair<CMSER*,CMSER*> > &matches);
	 *
	 * @brief	Generates an image.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @param	filename	   	Filename of the file.
	 * @param [in,out]	matches	[in,out] If non-null, the matches.
	 */

	void GenerateImage(const char *filename, vector<pair<CMSER*,CMSER*> > &matches);
	~CMatchesImageGenerator(void);
};

