#pragma once
#include "MSERWrapper.h"

/**
 * @class	CMserPlusSiftMain
 *
 * @brief	A mser plus sift main.
 *
 * @author	Tato
 * @date	23/02/2014
 */

class CMserPlusSiftMain
{
public:
	CMserPlusSiftMain(void);
	~CMserPlusSiftMain(void);

	/**
	 * @fn	int CMserPlusSiftMain::DoMSERPlusSift(char *file1, char *file2, int delta, double matchThreshold);
	 *
	 * @brief	Executes the mser plus sift operation.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @param [in,out]	file1 	If non-null, the first file.
	 * @param [in,out]	file2 	If non-null, the second file.
	 * @param	delta		  	The delta.
	 * @param	matchThreshold	The match threshold.
	 *
	 * @return	An int.
	 */

	int DoMSERPlusSift(char *file1, char *file2, int delta, double matchThreshold);

	int GetMSERSiftFeatures(const int descriptorType, char *image, int delta, const CMSERList **msers, vector<vector<double*>* > **mserDescriptors, vector<CGrayscaleImage * > **mserRotations, vector<std::pair<double, double> > **mserTranslations, double *scale);
	static const int MSERTexture = 1;
	static const int MSERShape = 2;
};
