#pragma once
#include "GrayscaleImage.h"
#include "MSERWrapper.h"

/**
 * @class	CMultiscaleMSER
 *
 * @brief	A multiscale mser.
 *
 * @author	Tato
 * @date	23/02/2014
 */

class CMultiscaleMSER
{
private:
	int _scales;
	std::vector<CGrayscaleImage*> *_images;
	//CMSERList *_list;
public:

	/**
	 * @fn	CMultiscaleMSER::CMultiscaleMSER(CGrayscaleImage *img);
	 *
	 * @brief	Constructor.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @param [in,out]	img	If non-null, the image.
	 * @param [in]		scales	Amount of scales to compute
	 */

	CMultiscaleMSER(CGrayscaleImage *img, int scales);

	/**
	 * @fn	const CMSERList CMultiscaleMSER::*GetMSERList();
	 *
	 * @brief	Gets mser list.
	 *
	 * @author	Tato
	 * @date	23/02/2014
	 *
	 * @return	null if it fails, else the mser list.
	 */

	const CMSERList *GetMSERList();
	~CMultiscaleMSER(void);
};

