#pragma once
#include <iostream>
#include <string>
#include <sstream>
#include <ostream>

class CParams
{
private:
	static CParams* _instance;
	CParams();
public:

	// Singleton
	static CParams* Instance();
	static void KillInstance() { delete _instance; }
	void SetDefaultShapeParams();
	void SetDefaultTextureParams();
	// Params
	int Ns;
	float s;
	float sigmap;
	int Nb;
	float sigmah;
	float sigmad;
	double virtualPatchSize;
	// Params MSER
	int delta;
	int minimumEllipseLength; // In pixels
	double minDiversity;
	int minimumMSERArea; // In pixels
	int qtyScales; // Amount of scales used to compute Multiscale MSER
	// Params Matching
	double matchThreshold;
	// Params RANSAC
	float ransacMaxErr;

};

