#include <math.h>
#include <limits>

template <bool> struct static_asserta;
template <> struct static_asserta<true> { };

template<typename T>
inline bool is_NaN(T const& x) {
    static_cast<void>(sizeof(static_asserta<std::numeric_limits<T>::has_quiet_NaN>));
    return std::numeric_limits<T>::has_quiet_NaN && (x != x);
}

template <typename T>
inline bool is_inf(T const& x) {
    static_cast<void>(sizeof(static_asserta<std::numeric_limits<T>::has_infinity>));
    return x == std::numeric_limits<T>::infinity() || x == -std::numeric_limits<T>::infinity();
}

template <typename T>
inline bool isFinite(T const& x) 
{
    return (!is_inf(x) && !is_NaN(x));
}

